docker_prune – Allows to prune various docker objects — Ansible Documentation

- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# docker_prune – Allows to prune various docker objects

New in version 2.8.

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Allows to run `docker container prune`, `docker image prune`, `docker network prune` and `docker volume prune` via the Docker API.

## Requirements

The below requirements are needed on the host that executes this module.

- Docker API >= 1.25
- Docker SDK for Python: Please note that the docker-py Python module has been superseded by docker (see here for details). This module does not work with docker-py.
- Docker SDK for Python >= 2.1.0
- Python >= 2.7

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
api_version string | Default: "auto" | The version of the Docker API running on the Docker Host. Defaults to the latest version of the API supported by Docker SDK for Python and the docker daemon. If the value is not specified in the task, the value of environment variable `DOCKER_API_VERSION` will be used instead. If the environment variable is not set, the default value will be used. aliases: docker_api_version
builder_cache boolean | Choices: no ← yes | Whether to prune the builder cache. Requires version 3.3.0 of the Docker SDK for Python or newer.
ca_cert path |  | Use a CA certificate when performing server verification by providing the path to a CA certificate file. If the value is not specified in the task and the environment variable `DOCKER_CERT_PATH` is set, the file `ca.pem` from the directory specified in the environment variable `DOCKER_CERT_PATH` will be used. aliases: tls_ca_cert, cacert_path
client_cert path |  | Path to the client's TLS certificate file. If the value is not specified in the task and the environment variable `DOCKER_CERT_PATH` is set, the file `cert.pem` from the directory specified in the environment variable `DOCKER_CERT_PATH` will be used. aliases: tls_client_cert, cert_path
client_key path |  | Path to the client's TLS key file. If the value is not specified in the task and the environment variable `DOCKER_CERT_PATH` is set, the file `key.pem` from the directory specified in the environment variable `DOCKER_CERT_PATH` will be used. aliases: tls_client_key, key_path
containers boolean | Choices: no ← yes | Whether to prune containers.
containers_filters dictionary |  | A dictionary of filter values used for selecting containers to delete. For example, `until: 24h`. See the docker documentation for more information on possible filters.
debug boolean | Choices: no ← yes | Debug mode
docker_host string | Default: "unix://var/run/docker.sock" | The URL or Unix socket path used to connect to the Docker API. To connect to a remote host, provide the TCP connection string. For example, `tcp://192.0.2.23:2376`. If TLS is used to encrypt the connection, the module will automatically replace `tcp` in the connection URL with `https`. If the value is not specified in the task, the value of environment variable `DOCKER_HOST` will be used instead. If the environment variable is not set, the default value will be used. aliases: docker_url
images boolean | Choices: no ← yes | Whether to prune images.
images_filters dictionary |  | A dictionary of filter values used for selecting images to delete. For example, `dangling: true`. See the docker documentation for more information on possible filters.
networks boolean | Choices: no ← yes | Whether to prune networks.
networks_filters dictionary |  | A dictionary of filter values used for selecting networks to delete. See the docker documentation for more information on possible filters.
ssl_version string |  | Provide a valid SSL version number. Default value determined by ssl.py module. If the value is not specified in the task, the value of environment variable `DOCKER_SSL_VERSION` will be used instead.
timeout integer | Default: 60 | The maximum amount of time in seconds to wait on a response from the API. If the value is not specified in the task, the value of environment variable `DOCKER_TIMEOUT` will be used instead. If the environment variable is not set, the default value will be used.
tls boolean | Choices: no ← yes | Secure the connection to the API by using TLS without verifying the authenticity of the Docker host server. Note that if validate_certs is set to `yes` as well, it will take precedence. If the value is not specified in the task, the value of environment variable `DOCKER_TLS` will be used instead. If the environment variable is not set, the default value will be used.
tls_hostname string | Default: "localhost" | When verifying the authenticity of the Docker Host server, provide the expected name of the server. If the value is not specified in the task, the value of environment variable `DOCKER_TLS_HOSTNAME` will be used instead. If the environment variable is not set, the default value will be used.
validate_certs boolean | Choices: no ← yes | Secure the connection to the API by using TLS and verifying the authenticity of the Docker host server. If the value is not specified in the task, the value of environment variable `DOCKER_TLS_VERIFY` will be used instead. If the environment variable is not set, the default value will be used. aliases: tls_verify
volumes boolean | Choices: no ← yes | Whether to prune volumes.
volumes_filters dictionary |  | A dictionary of filter values used for selecting volumes to delete. See the docker documentation for more information on possible filters.

## Notes

Note

- Connect to the Docker daemon by providing parameters with each task or by defining environment variables. You can define `DOCKER_HOST`, `DOCKER_TLS_HOSTNAME`, `DOCKER_API_VERSION`, `DOCKER_CERT_PATH`, `DOCKER_SSL_VERSION`, `DOCKER_TLS`, `DOCKER_TLS_VERIFY` and `DOCKER_TIMEOUT`. If you are using docker machine, run the script shipped with the product that sets up the environment. It will set these variables for you. See https://docs.docker.com/machine/reference/env/ for more details.
- When connecting to Docker daemon with TLS, you might need to install additional Python packages. For the Docker SDK for Python, version 2.4 or newer, this can be done by installing `docker[tls]` with pip.
- Note that the Docker SDK for Python only allows to specify the path to the Docker configuration for very few functions. In general, it will use `$HOME/.docker/config.json` if the `DOCKER_CONFIG` environment variable is not specified, and use `$DOCKER_CONFIG/config.json` otherwise.

## Examples

    - name: Prune containers older than 24h
      docker_prune:
        containers: yes
        containers_filters:
          # only consider containers created more than 24 hours ago
          until: 24h

    - name: Prune everything
      docker_prune:
        containers: yes
        images: yes
        networks: yes
        volumes: yes
        builder_cache: yes

    - name: Prune everything (including non-dangling images)
      docker_prune:
        containers: yes
        images: yes
        images_filters:
          dangling: false
        networks: yes
        volumes: yes
        builder_cache: yes

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
builder_cache_space_reclaimed integer | builder_cache is `true` | Amount of reclaimed disk space from builder cache pruning in bytes. Sample: 0
containers list / elements=string | containers is `true` | List of IDs of deleted containers. Sample: []
containers_space_reclaimed integer | containers is `true` | Amount of reclaimed disk space from container pruning in bytes. Sample: 0
images list / elements=string | images is `true` | List of IDs of deleted images. Sample: []
images_space_reclaimed integer | images is `true` | Amount of reclaimed disk space from image pruning in bytes. Sample: 0
networks list / elements=string | networks is `true` | List of IDs of deleted networks. Sample: []
volumes list / elements=string | volumes is `true` | List of IDs of deleted volumes. Sample: []
volumes_space_reclaimed integer | volumes is `true` | Amount of reclaimed disk space from volumes pruning in bytes. Sample: 0

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Felix Fontein (@felixfontein)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.